# Adding Custom Identifiers

To identify users, we provide you with the **zipy.identify()** function in our SDK. [You can read more about this here](https://docs.zipy.ai/configure/identifying-users). Zipy now supports two kinds of identifiers - predefined and custom identifiers.

**Predefined identifiers**

You can use one or more of the following predefined identifiers when you call zipy.identify():

* **firstName** - String&#x20;
* **lastName** - String&#x20;
* **email** - String&#x20;
* **customerName** - String&#x20;
* **avatar** - String&#x20;
* **phone** - String&#x20;
* **age** - String&#x20;

**Custom identifiers**

We allow a maximum of 10 custom identifiers per project which can be created as per your use-case. To use custom identifiers, you can add them to the existing userInfo JSON in Zipy’s identify method:&#x20;

zipy.identify(uid, \[userInfo])

<br>

**Example Usage:**

To uniquely identify your users with Zipy using your own custom identifiers e.g. “city”, “state” & “country”, update your existing zipy.identify method as given below:

```javascript
window.zipy.identify("jdoe@yourcompany.com", {
   firstName: "John",
   lastName: "Doe",
   email: "jdoe@yourcompany.com",
   customerName: "Your Company",
   age: "34",
   city:  "Los Angeles",
   state: "California",
   country: "United States of America"
});
```

In case your custom identifier key has a special character (space, - , \_ etc), please quote the key within double quotes inside the JSON e.g.:

```javascript
"emp_city": "Los Angeles"
```

This **userInfo** including the custom identifiers will be captured by Zipy and can be viewed in the User Environment details in each user session, as shown in the image below:

![](https://s3-ap-south-1.amazonaws.com/ind-cdn.freshdesk.com/data/helpdesk/attachments/production/82025114905/original/sVMen8OGWGit6f2LMz40t5z6uw_jwhIe6g.png?1643966838)

The custom identifiers can also be used to filter your sessions & errors.

**In case you want to add your own custom identifiers in addition to the identifiers we have defined for you, please raise a support ticket with the list of custom identifier names for your project so that we can add them for you. Alternatively, you can use the chat widget in the Zipy application for the required support.**<br>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zipy.ai/configure/adding-custom-identifiers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
